<template>
  <div>
    <DoughnutChart
      :chart-data="datacollection"
      :options="options"
      :height="300"
    />
  </div>
</template>
<script>
import DoughnutChart from '@/components/chart/doughnut.js'
import covertDate from '@/mixins/formateDate'
import axios from 'axios'
export default {
  mixins: [covertDate],
  components: {
    DoughnutChart,
  },
  props: {
    setDataDate: Number,
  },
  data() {
    return {
      datacollection: null,
      loaded: false,
      setTotalData: [],
      setLabel: [],
      setBGColor: [],
      options: null,
    }
  },
  mounted() {
    this.fillData()
    this.getDataAxios()
  },
  watch: {
    getdashboardTime(newVal, oldVal) {
      this.getDataAxios(
        this.$nuxt.$store.state.template.dashboardTime,
        this.$nuxt.$store.state.expensestable.ExpensesTable,
        this.$nuxt.$store.state.expensestype.ExpensesType
      )
    },
  },
  methods: {
    fillData() {
      this.datacollection = {
        labels: this.setLabel,
        datasets: [
          {
            label: ['ค่าใช้จ่ายรายวัน'],
            data: this.setTotalData,
            backgroundColor: this.setBGColor,
            borderColor: ['#FFF'],
            borderWidth: 1,
          },
        ],
      }
      this.options = {
        responsive: true,
        title: {
          display: true,
          text: 'Custom Chart Title',
          position: 'Top',
        },
        animation: {
          animateScale: true,
          animateRotate: true,
        },
        tooltip: {
          trigger: 'item',
          formatter: '{a} <br/>{b} : {c} ({d}%)',
        },
        legend: {
          position: 'left',
          labels: {
            fontColor: 'rgb(154, 154, 154)',
            fontSize: 11,
            usePointStyle: true,
            padding: 20,
          },
        },
        cutoutPercentage: 50,
        labels: {
          showActualPercentages: true,
        },
        responsive: true,
        maintainAspectRatio: false,
        plugins: {
          datalabels: {
            formatter: function (value) {
              if(value == 0){
                return ''
              }
              return parseInt(value).toLocaleString('th-TH', {
                style: 'currency',
                currency: 'THB',
              })
            },
            color: 'blue',
            labels: {
              title: { color: 'blue', font: { weight: 'bold' } },
              value: { color: 'green' },
            },
          },
        },
      }
    },
    async getDataAxios(
      timeVal = new Date(),
      expensestable = 0,
      expensestype = 0
    ) {
      if (expensestable) {
        const checkTime = timeVal

        const date = new Date(checkTime)
        const firstDay = new Date(date.getFullYear(), 0, 1)
        const lastDay = new Date(date.getFullYear(), 11, 31)

        const dayStart = firstDay.getTime()
        const dayEnd = lastDay.getTime()

        const dataRes = this.totalTypeMulti(expensestable, dayStart, dayEnd)
        const countName = expensestype.map((x) => x.name).length

        this.setTotalData = this.setArray(dataRes, countName)
        this.setLabel = expensestype.map((x) => x.name)
        this.setBGColor = this.setObjectBG(countName)

        this.fillData()
      }
    },
    setArray(objData, coutName) {
      const arrayDeserts = new Array(coutName)
      for (let i = 0; i < coutName; i++) {
        objData.forEach((res) => {
          if (res.id - 1 == i) {
            if (arrayDeserts[i] > 0) {
              arrayDeserts[i] = arrayDeserts[i] + res.price
            } else {
              arrayDeserts[i] = res.price
            }
          }
        })
        if (arrayDeserts[i] == null) {
          arrayDeserts[i] = ''
        }
      }
      return arrayDeserts
    },
  },
}
</script>
